ANARC09A - Seinfeld


I’m out of stories. For years I’ve been writing stories, some rather silly, just to make simple problems look difficult and complex problems look easy. But, alas, not for this one.

You’re given a non empty string made in its entirety from opening and closing braces. Your task is to find the minimum number of “operations” needed to make the string stable. The definition for being stable is as follows:

  1. An empty string is stable.
  2. If S is stable, then {S} is also stable.
  3. If S and T are both stable, then ST (the concatenation of the two) is also stable.

All of these strings are stable: {}, {}{}, and {{}{}}; But none of these: }{, {{}{, nor {}{.
The only operation allowed on the string is to replace an opening brace with a closing brace, or vice-versa.

Input

Your program will be tested on one or more data sets. Each data set is described on a single line. The line is a non-empty string of opening and closing braces and nothing else. No string has more than 2000 braces. All sequences are of even length.

The last line of the input is made of one or more ’-’ (minus signs.)

Output

For each test case, print the following line:

k. N

Where k is the test case number (starting at one,) and N is the minimum number of operations needed to convert the given string into a balanced one.

Example

Input:
}{
{}{}{}
{{{}
---

Output: 1. 2
2. 0
3. 1

hide comments
mahilewets: 2017-08-28 12:25:04

I have solved it

But don't proved the correctness

arora_shivam: 2017-08-24 19:22:51

done in O(n) complexity

surajmall: 2017-08-09 19:54:33

Need good observation for this problem

jaideeppyne: 2017-07-05 15:03:38

Be careful with the output format. Got 1 WA for that. :( Use adhoc process.No need of stack. You can find a good method of how to approach the question in adhoc way without use of stacks on Quora . The explanation available is nice.

vivace: 2017-06-30 11:50:42

solvable using dp as well... O(n^2)

viratian_070: 2017-06-14 07:36:26

no stack needed.....think simple...simple adhoc problem

da_201501181: 2017-05-26 13:58:27

O(n) without Stack..!! -:)

iammangod96: 2017-05-19 11:36:38

stack.size()/2 + cnt

omprakash_40: 2017-04-10 07:02:43

don't go after dynamic programming tag..
use stack ..it is very easy using stack....AC .

vivace: 2017-04-01 01:29:59

read the question carefully @a_kk
and also see the output format carefully . I got 2 WAs because of that .

Last edit: 2017-04-01 02:43:17

Added by:Mohammad Kotb
Date:2009-11-28
Time limit:3.236s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ASM64 BASH JS-RHINO
Resource:http://www.icpc-anarc.org